package com.example.barcodedemo;

import android.widget.EditText;
import android.widget.TextView;
import android.view.KeyEvent;
import android.view.inputmethod.EditorInfo;
import android.widget.TextView.OnEditorActionListener;
import android.app.Activity;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.Menu;

public class MainActivity extends Activity {

	private static Resources m_Res;
	boolean b_codeReader = false;
	final int ID_LED=19831111;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        m_Res = getResources();
        
        EditText inputCodeEditText = (EditText)findViewById(R.id.editText_getCode);
        inputCodeEditText.setText("");
        
        //Get Barcode data once it is written
        inputCodeEditText.setOnEditorActionListener(new OnEditorActionListener() {

        	public boolean onEditorAction(TextView v, int actionId, KeyEvent event)
        	{
                switch(actionId)
                {
                	case EditorInfo.IME_ACTION_UNSPECIFIED:
                		{
                			//Barcode data has been passed to TextView
                    		String inputCode = (String)v.getText().toString();
                		}
                		return true;
                }
                return true;
        	}
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
    
    //Key pressing will trigger onKeyDown
    //And different keyCode will lead to different KeyEvent
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
    	super.onKeyDown(keyCode, event);
    	TextView tvTestName = (TextView)findViewById(R.id.textView2);

		try{
        switch(keyCode)
        {
        	case KeyEvent.KEYCODE_VOLUME_UP://Volume up
        		tvTestName.setText(getStr(R.string.Volume_UP));
        		return true;
        	case KeyEvent.KEYCODE_VOLUME_DOWN://Volumn down
        		tvTestName.setText(getStr(R.string.Volume_down));
        		return true;
        	case KeyEvent.KEYCODE_UNKNOWN://Barcode scan
        		tvTestName.setText(getStr(R.string.strBarcode));
        		return true;
        	case KeyEvent.KEYCODE_BACK:
        		finish();
        		return true;
        }
        return false;
		}
		catch(Exception ex)
		{
    	    return false;
		}
    }
    
    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
    	super.onKeyUp(keyCode, event);
    	switch(keyCode)
    	{
    		case KeyEvent.KEYCODE_UNKNOWN:
    			return true;
    	}
    	return false;
    }
    
    private String getStr(int nStringID)
    {
    	try{
    		return m_Res.getString(nStringID);
    	}
    	catch(Exception ex)
    	{
    	    return null;
    	}
    }
}

